/******************************************************************************
 * $Id: functions.h,v 1.134 2000/07/22 17:35:05 jimb Exp $
 * Author		: Jim Brooks	<jim@jimbrooks.org>
 * Description	: Function prototypes.
 ******************************************************************************/

/*
 * main.c
 */
void InitGlobals( void );
void ParseCommandLine( int argc, char* argv[] );

/*
 * widgets.c
 */
void CreateWidgets( void );
void CreateMainWindow( void );
void CreateMenubarToolbar( void );
void ChangeStyleColorText( GtkWidget* pWidget,
                           GdkColor*  pColorFg,
                           GdkColor*  pColorBg );
void ChangeStyleColorSel( GtkWidget* pWidget,
                          GdkColor*  pColorFg,
                          GdkColor*  pColorBg );
gboolean ChangeStyleFont( GtkWidget* pWidget,
                          char*      pFontName );
gint FontHeight( GdkFont* pFont );
void PositionShowDialogAtMiddle( GtkWidget* pWidgetDialog );
void PositionShowFindDialog( GtkWidget* pWidgetDialog,
                             gboolean   howToPosition );
void WidgetWidthHeight( GtkWidget* pWidget,
                        gint*      pWidth,
                        gint*      pHeight );
void WidgetGeom( GtkWidget* pWidget,
                 gint*      pX,
                 gint*      pY,
                 gint*      pW,
                 gint*      pH );
void PrependComboDropDown( char*   pString,
                           GList** ppGList );
GtkWidget* CreateButtonLabelUnderlined( const gchar* pLabelText,
                                        const gchar* pLabelPattern );

/*
 * handlers.c
 */
gboolean HandlerKeyPressMain( GtkWidget*   pWidget,
                              GdkEventKey* pEvent,
                              gpointer     unused );
gboolean HandlerKeyPressReleaseText( GtkWidget*   pWidget,
                                     GdkEventKey* pEvent,
                                     gpointer     unused );
gboolean HandlerKeyPressDialogFind( GtkWidget*   pWidget,
                                    GdkEventKey* pEvent,
                                    gpointer     unused );
gboolean HandlerKeyPressDialogLine( GtkWidget*   pWidget,
                                    GdkEventKey* pEvent,
                                    gpointer     unused );
gboolean HandlerActivateComboLine( GtkWidget*   pWidget,
                                   GdkEventKey* pEvent,
                                   gpointer     unused );
gboolean HandlerLineNum( GtkWidget*      pWidget,
                         GdkEventButton* pEvent,
                         gpointer        ununsed );
void HandlerToolbarButtonEarlierTag( GtkWidget* pWidgetUnused,
                                     gpointer   unused );
void HandlerToolbarButtonLaterTag( GtkWidget* pWidgetUnused,
                                   gpointer   unused );
void HandlerToolbarButtonGotoTag( GtkWidget* pWidgetUnused,
                                  gpointer   unused );
void HandlerToolbarButtonRecordCursor( GtkWidget* pWidgetUnused,
                                       gpointer   unused );
void HandlerSwitchPageNotebook( GtkNotebook*     pNotebook,
                                GtkNotebookPage* pNotebookPage,
                                gint             page_num,
                                gpointer         unused );
void HandlerDrawClistKludge( GtkWidget*    pWidget,
                             GdkRectangle* pRect,
                             gpointer      unused );
void InstallFocusHandlers( GtkWidget* pWidget );
gboolean HandlerFocusIn( GtkWidget*     pWidget,
                         GdkEventFocus* pEvent,
                         gpointer       unused );
gboolean HandlerFocusOut( GtkWidget*     pWidget,
                         GdkEventFocus* pEvent,
                         gpointer       unused );
void WordAtCursorClicked( void );
gboolean HandlerFocusbarExpose( GtkWidget*      pWidget,
                                GdkEventExpose* pEvent,
                                gpointer        pFocusbar );

/*
 * list.c
 */
void CreateTagsClistWidget( void );
void CreateInvisibleTagsClistWidget( GtkWidget** ppWidgetScrolled,
                                     GtkWidget** ppWidgetClist,
                                     int         columnsLayout,
                                     PFUNC       RowSelectCallback,
                                     PFUNC       RowUnselectCallback );
void CreateModulesClistWidget( void );
void PopulateTagsClistWidget( int sort );
void PopulateModulesClistWidget( void );
void TagsClistWidgetRowSelectCallback( GtkWidget*      pWidget,
                                       gint            row,
                                       gint            col,
                                       GdkEventButton* pEvent,
                                       gpointer	       pData );
void ModulesClistWidgetRowSelectCallback( GtkWidget*      pWidget,
                                          gint            row,
                                          gint            col,
                                          GdkEventButton* pEvent,
                                          gpointer        pData );
void TagsClistWidgetRowUnselectCallback( GtkWidget*      pWidget,
                                         gint            row,
                                         gint            col,
                                         GdkEventButton* pEvent,
                                         gpointer	 pData );
void ModulesClistWidgetRowUnselectCallback( GtkWidget*      pWidget,
                                            gint            row,
                                            gint            col,
                                            GdkEventButton* pEvent,
                                            gpointer	    pData );
void SelectClistRow( GtkWidget* pWidgetClist,
                     gint       row );
void SelectClistRowAsThoughUserDid( GtkWidget* pWidgetClist,
                                    gint       row );
void UnselectClistRow( GtkWidget* pWidgetClist,
                       gint*      pSelectedRow );
void AddSortedModuleGlist( gpointer pModuleName,
                           gpointer pUnused,
                           gpointer ppGlist );
void AddRowToAnyTagsClistWidget( GtkWidget* pWidgetClist,
                                 gpointer   pData,
                                 gpointer   pUnused,
                                 gboolean   prependOrAppend,
                                 int*       pRowCount );
void AddRowToTagsClistWidget( gpointer pData,
                              gpointer pUnused );
void AddRowToModulesClistWidget( gpointer pModuleName,
                                 gpointer pUnused );
gint SearchClistWidget( gchar*     pSought,
                        GtkWidget* pWidgetClist,
                        int        totalRows,
                        int        selectedRow,
                        int        exactMatch,
                        int        quiet,
                        gboolean   updateNotebook,
                        gboolean   doSelectRow );

/*
 * history.c
 */
void CreateHistoryClistWidget( void );
void HistoryClistWidgetRowSelectCallback( GtkWidget*      pWidget,
                                          gint            row,
                                          gint            col,
                                          GdkEventButton* pEvent,
                                          gpointer	       pData );
void HistoryClistWidgetRowUnselectCallback( GtkWidget*      pWidget,
                                            gint            row,
                                            gint            col,
                                            GdkEventButton* pEvent,
                                            gpointer        pData );
void PrependTagHistory( struct TAG* pTag );
void UndoPrependTagHistory( void );
void StepHistoryList( gboolean stepDown );

/*
 * text.c
 */
void CreateTextWidgetEtAl( void );
FUNC_X LoadTextWidgetWithModule( gchar*	pModule,
                                 gint	cursor,
                                 gint	row );
void LoadTextWidgetWithBuffer( gpointer	pBuffer,
                               gint	bufferSize );
void CopyOutTextWidget( void );
void ClearTextWidget( void );
int IsTextWidgetEmpty( void );
int LineAtCursor( void );
void ScrollTextWidgetToLine( int   line,
                             float vertFrac );
void RecenterTextWidget( void );
void RecordLocationAsPrevious( void );
void GotoPrev( void );
void GotoLine( void );
gboolean HighlightLine( int line );
void HighlightWordInCurrentLine( const char* pWord );
void HighlightTextString( gchar* pText,
                          gint   idx,
                          gint   len );
void HighlightTag( struct TAG* pTag );
void PrintLineNum( void );
gint IdlePrintLineNum( gpointer dontCare );
guint TextCursorIdx( void );
gboolean IsCursorOverWord( void );
GString* ScoopWordAtCursor( int   maxWordLen,
                            char* pText,
                            int   textLen,
                            int   idxCursor );

/*
 * notebook.c
 */
void CreateNotebook( void );
int NotebookPageTags( void );
int NotebookPageModules( void );
int NotebookPageHistory( void );
int NotebookPageFound( void );

/*
 * find.c
 */
gchar* FindStringInSegment( gchar* pSought,
                            gchar* pSegment,
                            int    segmentLen );
gboolean FindNextStringInTextWidget( void );
void FindTagCheckMultipleMatches( char* pTagName );
void FindNextTextOrTag( void );
gint FindNextTag( void );
gboolean FindStringInTextWidget( gchar*   pSought,
                                 gboolean tryWrap,
                                 gboolean quiet,
                                 gboolean scroll,
                                 gint*    pReturnLineNumFound );
gboolean FindStringInTextWidget_( gchar*   pSought,
                                  gboolean tryWrap,
                                  gboolean quiet,
                                  gboolean scroll,
                                  gint*    pReturnLineNumFound,
                                  gchar*   pText,
                                  gint     textLen );
gboolean FindStringGlobal( gchar*   pSought,
                           gboolean quiet );
void BuildListOfFoundStrings( gchar*   pSought,
                              gboolean quiet );
FUNC_X AppendFoundTagsList( gchar* pTagName,
                            gchar* pModuleName,
                            gint   lineNum );
void BuildNotebookPageWithFindResults( void );
void AddRowToFoundClistWidget( gpointer pData,
                               gpointer pUnused );
void FoundClistWidgetRowSelectCallback( GtkWidget*      pWidget,
                                        gint            row,
                                        gint            col,
                                        GdkEventButton* pEvent,
                                        gpointer	    pData );
void FoundClistWidgetRowUnselectCallback( GtkWidget*      pWidget,
                                          gint            row,
                                          gint            col,
                                          GdkEventButton* pEvent,
                                          gpointer	     pData );

/*
 * popup.c
 */
void Popup( char*    pMsg,
            char*    pTitle,
            int      whichFont );
void PopupClose( GtkWidget* pWidget,
                 gpointer   pData );
void PopupClosing( GtkWidget* pWidget,
                   gpointer   pData );

/*
 * statusbar.c
 */
void RecordStatusbarMsg( gchar* pMsg );
void PrintStatusbar( gchar* pMsg );
void PrintStatusbarThirds( gchar* pMsg1,
                           gchar* pMsg2,
                           gchar* pMsg3 );
void PrintStatusbarForRow( gchar* pMsg,
                           gint   row );
gint RowAssociatedWithStatusbar( void );
void SetStatusbarInitialMsg( gchar* pMsg );
void ClearStatusbar( void );
void MostlyClearStatusbar( void );
void EnableStatusbarTimeout( void );
gint StatusbarTimedOut( gpointer unused );

/*
 * focusbar.c
 */
focusbar_t* FocusbarCreate( char* pFontName );
void FocusbarDestroy( focusbar_t* pFocusbar );
void FocusbarLabelSet( focusbar_t* pFocusbar,
                       char*       pStr );
void FocusbarFocusGain( focusbar_t* pFocusbar );
void FocusbarFocusLose( focusbar_t* pFocusbar );
void FocusbarPaint( focusbar_t* pFocusbar );

/*
 * tags.c
 */
void ProcessCtagsFromFile( char* pFilename );
void ProcessCtagsFromStdin( void );
GList* CreateTagsGlist( char* pCtags,
                        long  ctagsSize );
GList* CreateTagsGlistThreaded( char* pCtags,
                                long  ctagsSize );
void* ThreadCreateTagsGlist( void* p1 );
void ResortTagsGlist( int sort );
void ResortTagsGlistCallback( gpointer pTag,
                              gpointer ppGlistTagsNew );
gint ResortTagsGlistCompare( gconstpointer pTag1,
                             gconstpointer pTag2 );
gint CompareTags( const PTAG pTag1,
                  const PTAG pTag2,
                  int        member );
FUNC_X AddCtagsLineToTagsGlist( const char* pLine,
                                GList**     ppGlist );
struct TAG* AllocTagStruct( void );
void FreeTagStruct( struct TAG* pTag );
void FillTagStruct( struct TAG* pTag,
                    gchar*      pName,
                    gint        lineNum,
                    gchar*      pType,
                    gchar*      pModule );
char* ReadCtagsFromFile( long* pCtagsSize, /* out */
                         char* pFilename );
FUNC_X CheckTagType( const char* pTagType );
void GotoTagUnderCursor( void );
int IsTagChar( gchar c );

/*
 * menu.c
 */
void CreateMenubar( GtkWidget* pWidgetHbox );
void MenuItemSelected( gpointer   pData,
                       guint      menuItem,
                       GtkWidget* pWidget );
void MenuItemFindTag( void );
void CreateFindDialog( MENU_ITEM menuItem );
void FindDialogClose( void );
void FindDialogClickedFind( void );
void CheckButtonFindToggled( GtkWidget* pWidget,
                             gpointer   pData );
void CheckButtonFindGlobalToggled( GtkWidget* pWidget,
                                   gpointer   pData );
void CheckButtonFindReverseToggled( GtkWidget* pWidget,
                                    gpointer   pData );

/*
 * toolbar.c
 */
void CreateToolbar( GtkWidget* pWidgetHbox );

/*
 * module.c
 */
gpointer ModuleBuffer( gchar* pModuleName,
                       long*  pModuleSize /* out */ );
guint HashModuleKey( gconstpointer pKey );
gint HashModuleCmp( gconstpointer  pName1,
                    gconstpointer  pName2 );

/*
 * file.c
 */
gpointer LoadFile( gchar* pFname,
                   long*  pFsize /* out */ );
GString* LoadFileSpecial( gchar* pFileName );
long FileSize( gchar* pFilename );

/*
 * utils.c
 */
/* --- inline --- */
extern inline int IsWhitespace( char c );
extern inline int IsEolUnix( const char* pc );
extern inline int IsEolMsdos( const char* pc );
extern inline int IsEol( const char* pc );
extern inline int IsLineEmpty( const char* pLine );
extern inline
void CopyString( char*       pDest,
                 const char* pSrc,
                 int         amount );
extern inline
const char* PastWord( const char* pWord,
                      int         size );
extern inline
const char* PastWhitespace( const char* pc,
                            int         max );
extern inline char* CreateString( int size );
extern inline void DeleteString( char* p );
/* -------------- */
FUNC_X ParseWord( const char*  pc,
                  const char** ppWord,
                  int          max );
const char* PastWord( const char* pWord,
                      int         size );
const char* NextLine( const char* pc,
                      int         max );
const char* ToLine( const char*	pc,
                    int		line,
                    int		maxLineSize );
char* ToEol( const char* pLine,
             int         max );
gint LineIdx2LineNum( gchar* pText,
                      gint   idx );
const char* PastEol( const char* pc );
const char* PastWhitespace( const char* pc,
                            int         max );
int IsWordChar( gchar c );
GString* CreateGString( char* pInit,
                        int   len );
void CopyString( char*       pDest,
                 const char* pSrc,
                 int         amount );
char* CreateString( int size );
void DeleteString( char* p );
size_t StrLen( const char* pStr );
char* FindSubstr( const char* pHaystack,
                  const char* pNeedle );
char* FindSubstrI( const char* pHaystack,
                   const char* pNeedle );
char* FindSubstrReverse( const char* pHaystackTop,
                         const char* pHaystackBottom,
                         const char* pNeedle,
                         P_FUNC_STRCMPX pFuncCmp );
void Warning( gchar*	pMsg );
void FreeGlistDynamic( GList* pGlist );
void FreeGlistDynamicFreeElem( gpointer pData,
                               gpointer pUnused );
gint HashStrcmp( gconstpointer pKey1,
                 gconstpointer pKey2 );
void ProcessPendingEvents( void );
#include "utils.h"

/*
 * sys_*.c
 */
int SysCpus( void );

/*
 * debug.c
 */
#ifdef HYPERSRC_DEBUG
void PrintUsecElapsed( GTimeVal* pTimeval1, GTimeVal* pTimeval2 );
#endif
