/******************************************************************************
 * $Id: globals.h,v 1.79 2000/07/22 03:23:49 jimb Exp $
 * Author		: Jim Brooks	<jim@jimbrooks.org>
 * Description	: Global data.
 ******************************************************************************/

#ifdef HYPERSRC_DEFINE_GLOBALS
#define GLOBAL
#define INIT(x) = x
#else
#define GLOBAL		extern
#define INIT(x) 
#endif

/*
 * Pointers to widgets.
 */
GLOBAL GtkWidget*      pWidgetMain;
GLOBAL GtkWidget*      pWidgetVbox;
GLOBAL GtkWidget*      pWidgetToolbar;
GLOBAL GtkWidget*      pWidgetToolbarButtonGotoLine;
GLOBAL GtkWidget*      pWidgetToolbarButtonGotoTag;
GLOBAL GtkWidget*      pWidgetToolbarButtonEarlierTag;
GLOBAL GtkWidget*      pWidgetToolbarButtonLaterTag;
GLOBAL GtkWidget*      pWidgetNotebook;
GLOBAL GtkWidget*      pWidgetClistTags;
GLOBAL GtkWidget*      pWidgetClistFound;
GLOBAL GtkWidget*      pWidgetClistModules;
GLOBAL GtkWidget*      pWidgetClistHistory;
GLOBAL GtkWidget*      pWidgetScrolledTags;
GLOBAL GtkWidget*      pWidgetScrolledFound;
GLOBAL GtkWidget*      pWidgetScrolledModules;
GLOBAL GtkWidget*      pWidgetScrolledHistory;
GLOBAL GtkWidget*      pWidgetText;
GLOBAL GtkWidget*      pWidgetTextVbox;
GLOBAL GtkWidget*      pWidgetTextTable;
GLOBAL GtkWidget*      pWidgetTextHscroll;
GLOBAL GtkWidget*      pWidgetTextVscroll;
GLOBAL GtkWidget*      pWidgetPaned;
GLOBAL GtkWidget*      pWidgetStatusbar;
GLOBAL GtkWidget*      pWidgetDialogFind;
GLOBAL GtkWidget*      pWidgetDialogLine;
GLOBAL GtkWidget*      pWidgetComboFind;
GLOBAL GtkWidget*      pWidgetComboLine;
GLOBAL GtkWidget*      pWidgetCheckButtonFind;
GLOBAL GtkWidget*      pWidgetCheckButtonFindGlobal;
GLOBAL GtkWidget*      pWidgetCheckButtonFindReverse;
GLOBAL GtkAccelGroup*  pAccelGroup;
GLOBAL GtkItemFactory* pItemFactory;

/*
 * Focusbars.
 */
GLOBAL focusbar_t* pFocusbarText;

/*
 * Tag and tag clist widget state.
 */
GLOBAL GList*	pGlistTags;								/* pointer to a glist of TAG structs */
GLOBAL GList*	pGlistFoundTags;						/* list of tagged lines resulting from Find/Global */
GLOBAL int		widgetTagsClistRows INIT(0);			/* how many rows the tags clist widget has */
GLOBAL int		widgetTagsClistWidthCol[WIDGET_TAGS_CLIST_COLUMNS];
GLOBAL int		widgetFoundClistWidthCol[WIDGET_FOUND_CLIST_COLUMNS];
GLOBAL gint		widgetTagsClistSelectedRow INIT(ROW_NONE);
GLOBAL int		tagsSorted;								/* amount of sorted tags */
GLOBAL int		tagsSortedPercentShown;					/* {0,5,10,..95} percentage being shown by statusbar */
GLOBAL int		textLeft INIT(FALSE);
GLOBAL int		tagsColumnsLayout INIT(TAG_COL_LAYOUT_TAG_MODULE_TYPE_LINE);

/*
 * Modules clist widget state.
 */
GLOBAL int		widgetModulesClistRows INIT(0);			/* how many rows the clist widget has */
GLOBAL int		widgetModulesClistWidthCol[WIDGET_MODULES_CLIST_COLUMNS];
GLOBAL gint		widgetModulesClistSelectedRow INIT(ROW_NONE);
GLOBAL int      returnEarlyModuleSelectCallback INIT(FALSE);

/*
 * History clist widget state.
 */
GLOBAL int		widgetHistoryClistRows INIT(0);			/* how many rows the clist widget has */
GLOBAL gint		widgetHistoryClistSelectedRow INIT(ROW_NONE);
GLOBAL gboolean prependingTagHistory INIT(FALSE);
GLOBAL gboolean activeHistoryRowSelect INIT(FALSE);

/*
 * State for all clists.
 */
GLOBAL gboolean rowSelectedByProgram INIT(0);

/*
 * Notebook state.
 */
GLOBAL gint	    notebookPageWithSelectedRow;
GLOBAL gboolean notebookPageFound INIT(FALSE);
GLOBAL gboolean kludgeNotebookSwitchPage INIT(FALSE);

/*
 * Statusbar state.
 */
GLOBAL guint	statusbarContextId;
GLOBAL guint	statusbarMsgs INIT(0);
GLOBAL gint		statusbarRow INIT(ROW_NONE);
GLOBAL gchar*	pStatusbarInitMsg;
GLOBAL GString* pGStringStatusbarMsg;
GLOBAL gint     timerStatusbar INIT(0);

/*
 * Misc. widget state.
 */
GLOBAL gint		widgetMainGeom[4];			/* x/y/w/h of main window */
GLOBAL gchar    mainWindowTitle[256];

/*
 * Find state.
 */
MENU_ITEM	soughtType;				/* either a tag or a text string */
GString*	pSoughtTag;
GString*	pSoughtText;
GString*	pSoughtModule;
gboolean	findCaseSens INIT(FALSE);
gboolean	findExactMatch INIT(FALSE);
gboolean    findGlobal INIT(FALSE);
gboolean	findReverse;
gint        findGeom[4];
GList**		ppGlistFindStrings;		/* ptr to pGlistFindStrings[Tag,Text,Module] */
GList*		pGlistFindStringsTag;
GList*		pGlistFindStringsText;
GList*		pGlistFindStringsModule;

/*
 * Goto line widget state.
 */
GList*		pGlistLineStrings;

/*
 * Dialog widget state.
 */
GLOBAL gboolean positionDialogAtMiddle;
GLOBAL gboolean buttonWordAtCursorFlag INIT(FALSE);

/*
 * Variables assigned via the command line.
 */
GLOBAL gint     cmdlineTabWidth INIT(0);

/*
 * Colors of the clist widgets.
 */
GLOBAL GdkColor colorClistWidgetTextFg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_CLIST_WIDGET_TEXT_FG_RED,
    COLOR_CLIST_WIDGET_TEXT_FG_GREEN,
    COLOR_CLIST_WIDGET_TEXT_FG_BLUE };
#else
;
#endif

GLOBAL GdkColor colorClistWidgetTextBg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_CLIST_WIDGET_TEXT_BG_RED,
    COLOR_CLIST_WIDGET_TEXT_BG_GREEN,
    COLOR_CLIST_WIDGET_TEXT_BG_BLUE };
#else
;
#endif

GLOBAL GdkColor colorClistWidgetSelFg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_CLIST_WIDGET_SEL_FG_RED,
    COLOR_CLIST_WIDGET_SEL_FG_GREEN,
    COLOR_CLIST_WIDGET_SEL_FG_BLUE };
#else
;
#endif

GLOBAL GdkColor colorClistWidgetSelBg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_CLIST_WIDGET_SEL_BG_RED,
    COLOR_CLIST_WIDGET_SEL_BG_GREEN,
    COLOR_CLIST_WIDGET_SEL_BG_BLUE };
#else
;
#endif

/*
 * Colors of the text widget.
 */
GLOBAL GdkColor colorTextWidgetTextFg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_TEXT_WIDGET_TEXT_FG_RED,
    COLOR_TEXT_WIDGET_TEXT_FG_GREEN,
    COLOR_TEXT_WIDGET_TEXT_FG_BLUE };
#else
;
#endif

GLOBAL GdkColor colorTextWidgetTextBg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_TEXT_WIDGET_TEXT_BG_RED,
    COLOR_TEXT_WIDGET_TEXT_BG_GREEN,
    COLOR_TEXT_WIDGET_TEXT_BG_BLUE };
#else
;
#endif

GLOBAL GdkColor colorTextWidgetSelFg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_TEXT_WIDGET_SEL_FG_RED,
    COLOR_TEXT_WIDGET_SEL_FG_GREEN,
    COLOR_TEXT_WIDGET_SEL_FG_BLUE };
#else
;
#endif
GLOBAL GdkColor colorTextWidgetSelBg
#ifdef HYPERSRC_DEFINE_GLOBALS
= { 0,
    COLOR_TEXT_WIDGET_SEL_BG_RED,
    COLOR_TEXT_WIDGET_SEL_BG_GREEN,
    COLOR_TEXT_WIDGET_SEL_BG_BLUE };
#else
;
#endif

/*
 * The name of the module that is currently loaded in the text widget.
 * Should be empty if the text widget is empty.
 */
GLOBAL gchar	moduleLoadedIntoTextWidget[MAX_FILENAME_LEN];

/*
 * Hash table for loaded modules.
 */
GLOBAL GHashTable* pHashModules;

/*
 * List of module names.
 */
GLOBAL GList* pGlistModuleNames;

/*
 * Name of file which holds tags.
 */
GLOBAL char*	pTagsFilename;

/*
 * Maximum amount of tags that can be processed (affected by --max-tags arg).
 */
GLOBAL int	maxTags INIT(MAX_TAGS_DEFAULT);

/*
 * Flags.
 */
GLOBAL int	hideTagLineColumn INIT(FALSE);

/*
 * Tag sort levels.
 */
GLOBAL int	sort1;
GLOBAL int	sort2;
GLOBAL int	sort3;

/*
 * Font names.
 */
GLOBAL char	fontNameText[256];
GLOBAL char	fontNameList[256];

/*
 * Misc.
 */
GLOBAL gboolean ctagsStdin INIT(FALSE);

/*
 * Vars for debugging/profiling.
 */
#ifdef HYPERSRC_DEBUG
GTimeVal timeval1;
GTimeVal timeval2;
#endif
