/******************************************************************************
 * $Id: types.h,v 1.14 2000/07/16 05:43:06 jimb Exp $
 * Author		: Jim Brooks	<jim@jimbrooks.org>
 * Description	: structs and typedefs
 ******************************************************************************/

/******************************************************************************
 * structs/typedefs
 ******************************************************************************/

/*
 * ###################################################
 * #   Each string should be dynamically allocated   #
 # #   in case later the TAG struct is deallocated.  #
 * ###################################################
 */
struct TAG
{
   char*	pName;			/* name of the tag */
   char*	pType;			/* type of tag, eg "func", "define", etc */
   char*	pLine;			/* which line (in string form) */
   int		lineInt;		/* which line (in integer form) */
   char*	pModule;		/* name of module the tag is in */
};
typedef struct TAG*			PTAG;

typedef struct
{
   gpointer	pModuleBuffer;
   long		moduleSize;
} HASH_ITEM_MODULE;
typedef HASH_ITEM_MODULE*	P_HASH_ITEM_MODULE;

typedef struct
{
   GtkWidget* pWidget;
   char       str[256];
   gboolean   focus;
   guint      fontHeight;
} focusbar_t;

/******************************************************************************
 * typedefs
 ******************************************************************************/

/*
 * For ptrs to strcmp() or strcase().
 */
typedef int FUNC_STRCMPX( const char* s1, const char *s2, size_t n);
typedef FUNC_STRCMPX* P_FUNC_STRCMPX;

/*
 * Misc. typedefs.
 */
typedef void FUNC(void);
typedef FUNC* PFUNC;
